window.Gleam.initSearch([{"doc":"le_ids","title":"le_ids","content":"# le_ids\n\n![CI](https://github.com/Sliden101/le_ids/workflows/test/badge.svg?branch=main)\n[![Package Version](https://img.shields.io/hexpm/v/ids)](https://hex.pm/packages/le_ids)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/le_ids/)\n\n✨ Unique IDs for Gleam\n\n## Supported\n\n- [CUID](https://github.com/ericelliott/cuid)\n- [UUID v4](https://en.wikipedia.org/wiki/Universally_unique_identifier)\n- [UUID v7](https://www.ietf.org/archive/id/draft-peabody-dispatch-new-uuid-format-04.html#section-5.2)\n- [NanoID](https://github.com/ai/nanoid)\n- [ULID](https://github.com/ulid/spec)\n- [Snowflake ID](https://en.wikipedia.org/wiki/Snowflake_ID)\n\n## Installation\n\nThe library is available on Hex so it can be added to your Gleam project by simply running:\n\n```sh\ngleam add le_ids\n```\n\n## References\n\n1. [Original CUID](https://en.wikipedia.org/wiki/Universally_unique_identifier)\n2. [Elixir CUID](https://github.com/duailibe/cuid)\n3. [Ecto UUID](https://github.com/elixir-ecto/ecto/blob/v3.5.4/lib/ecto/uuid.ex)\n4. [Elixir UUID](https://github.com/bitwalker/uniq)\n5. [Rust Snowflake ID](https://github.com/BinChengZhao/snowflake-rs)\n","url":"index.html"},{"doc":"le_ids/base32","title":"le_ids/base32","content":" Module for Base32 encoding.","url":"le_ids/base32.html"},{"doc":"le_ids/cuid","title":"Message","content":"pub opaque type Message\n The messages handled by the actor.\n\n The actor shouldn&#39;t be called directly so this type is opaque.\n\nSynonyms:\nle_ids/cuid.Message\nle_ids/cuid Message","url":"le_ids/cuid.html#Message"},{"doc":"le_ids/cuid","title":"State","content":"pub opaque type State\n The internal state of the actor.\n\n The state keeps track of a counter and a fingerprint.\n Both are used when generating a CUID.\n\nSynonyms:\nle_ids/cuid.State\nle_ids/cuid State","url":"le_ids/cuid.html#State"},{"doc":"le_ids/cuid","title":"generate","content":"pub fn generate(channel: Subject(Message)) -&gt; String\n Generates a CUID using the given channel.\n\n ### Usage\n \n import ids/cuid\n\n let assert Ok(channel) = cuid.start()\n\n let id: String = cuid.generate(channel)\n\n let slug: String = cuid.slug(channel)\n \nSynonyms:\nle_ids/cuid.generate\nle_ids/cuid generate","url":"le_ids/cuid.html#generate"},{"doc":"le_ids/cuid","title":"is_cuid","content":"pub fn is_cuid(id: String) -&gt; Bool\n Checks if a string is a CUID.\nSynonyms:\nle_ids/cuid.is_cuid\nle_ids/cuid is_cuid","url":"le_ids/cuid.html#is_cuid"},{"doc":"le_ids/cuid","title":"is_slug","content":"pub fn is_slug(slug: String) -&gt; Bool\n Checks if a string is a slug.\nSynonyms:\nle_ids/cuid.is_slug\nle_ids/cuid is_slug","url":"le_ids/cuid.html#is_slug"},{"doc":"le_ids/cuid","title":"slug","content":"pub fn slug(channel: Subject(Message)) -&gt; String\n Generates a slug using the given channel.\nSynonyms:\nle_ids/cuid.slug\nle_ids/cuid slug","url":"le_ids/cuid.html#slug"},{"doc":"le_ids/cuid","title":"start","content":"pub fn start() -&gt; Result(Subject(Message), StartError)\n Starts a CUID generator.\nSynonyms:\nle_ids/cuid.start\nle_ids/cuid start","url":"le_ids/cuid.html#start"},{"doc":"le_ids/cuid","title":"le_ids/cuid","content":" A module for generating CUIDs (Collision-resistant Unique Identifiers).\n The implementation requires a counter, so an actor is used to keep track\n of that state. This means before generating a CUID, an actor needs to be\n started and all work is done via a channel.\n\n Slugs are also supported.\n","url":"le_ids/cuid.html"},{"doc":"le_ids/nanoid","title":"default_alphabet","content":"pub const default_alphabet: BitArray\n The default alphabet used when generating NanoIDs.\nSynonyms:\nle_ids/nanoid.default_alphabet\nle_ids/nanoid default_alphabet","url":"le_ids/nanoid.html#default_alphabet"},{"doc":"le_ids/nanoid","title":"default_size","content":"pub const default_size: Int\n The default size of the generated NanoIDs. \nSynonyms:\nle_ids/nanoid.default_size\nle_ids/nanoid default_size","url":"le_ids/nanoid.html#default_size"},{"doc":"le_ids/nanoid","title":"generate","content":"pub fn generate() -&gt; String\n Generates a (random) NanoID. The NanoID produced by this function is \n generated using a cryptographically secure random number generator.\n\n ### Usage\n \n import ids/nanoid\n\n let assert Ok(id) = nanoid.generate()\n \n\nSynonyms:\nle_ids/nanoid.generate\nle_ids/nanoid generate","url":"le_ids/nanoid.html#generate"},{"doc":"le_ids/nanoid","title":"le_ids/nanoid","content":" A module for generating NanoIDs, i.e., tiny, secure, URL-friendly, \n and unique string IDs.\n","url":"le_ids/nanoid.html"},{"doc":"le_ids/snowflake","title":"Message","content":"pub opaque type Message\n The messages handled by the actor.\n The actor shouldn&#39;t be called directly so this type is opaque.\n\nSynonyms:\nle_ids/snowflake.Message\nle_ids/snowflake Message","url":"le_ids/snowflake.html#Message"},{"doc":"le_ids/snowflake","title":"State","content":"pub opaque type State\n The internal state of the actor.\n The state keeps track of the Snowflake parts.\n\nSynonyms:\nle_ids/snowflake.State\nle_ids/snowflake State","url":"le_ids/snowflake.html#State"},{"doc":"le_ids/snowflake","title":"decode","content":"pub fn decode(snowflake: Int) -&gt; Result(#(Int, Int, Int), String)\n Decodes a Snowflake ID into #(timestamp, machine_id, idx).\nSynonyms:\nle_ids/snowflake.decode\nle_ids/snowflake decode","url":"le_ids/snowflake.html#decode"},{"doc":"le_ids/snowflake","title":"generate","content":"pub fn generate(channel: Subject(Message)) -&gt; Int\n Generates a Snowflake ID using the given channel.\n\n ### Usage\n \n import ids/snowflake\n\n let assert Ok(channel) = snowflake.start(machine_id: 1)\n let id: Int = snowflake.generate(channel)\n \n let discord_epoch = 1_420_070_400_000 \n let assert Ok(d_channel) = snowflake.start_with_epoch(machine_id: 1, epoch: discord_epoch)\n let discord_id: Int = snowflake.generate(d_channel)\n \nSynonyms:\nle_ids/snowflake.generate\nle_ids/snowflake generate","url":"le_ids/snowflake.html#generate"},{"doc":"le_ids/snowflake","title":"start","content":"pub fn start(machine_id: Int) -&gt; Result(Subject(Message), String)\n Starts a Snowflake generator.\nSynonyms:\nle_ids/snowflake.start\nle_ids/snowflake start","url":"le_ids/snowflake.html#start"},{"doc":"le_ids/snowflake","title":"start_with_epoch","content":"pub fn start_with_epoch(\n  machine_id: Int,\n  epoch: Int,\n) -&gt; Result(Subject(Message), String)\n Starts a Snowflake generator with an epoch offset.\nSynonyms:\nle_ids/snowflake.start_with_epoch\nle_ids/snowflake start_with_epoch","url":"le_ids/snowflake.html#start_with_epoch"},{"doc":"le_ids/snowflake","title":"le_ids/snowflake","content":" A module for generating Snowflake IDs.","url":"le_ids/snowflake.html"},{"doc":"le_ids/ulid","title":"Message","content":"pub opaque type Message\n The messages handled by the actor.\n The actor shouldn&#39;t be called directly so this type is opaque.\n\nSynonyms:\nle_ids/ulid.Message\nle_ids/ulid Message","url":"le_ids/ulid.html#Message"},{"doc":"le_ids/ulid","title":"State","content":"pub opaque type State\n The internal state of the actor.\n The state keeps track of the last ULID components to make sure to handle the monotonicity correctly.\n\nSynonyms:\nle_ids/ulid.State\nle_ids/ulid State","url":"le_ids/ulid.html#State"},{"doc":"le_ids/ulid","title":"decode","content":"pub fn decode(ulid: String) -&gt; Result(#(Int, BitArray), String)\n Decodes an ULID into #(timestamp, randomness).\nSynonyms:\nle_ids/ulid.decode\nle_ids/ulid decode","url":"le_ids/ulid.html#decode"},{"doc":"le_ids/ulid","title":"from_parts","content":"pub fn from_parts(\n  timestamp: Int,\n  randomness: BitArray,\n) -&gt; Result(String, String)\n Generates an ULID with the supplied timestamp and randomness.\nSynonyms:\nle_ids/ulid.from_parts\nle_ids/ulid from_parts","url":"le_ids/ulid.html#from_parts"},{"doc":"le_ids/ulid","title":"from_timestamp","content":"pub fn from_timestamp(timestamp: Int) -&gt; Result(String, String)\n Generates an ULID with the supplied unix timestamp in milliseconds.\nSynonyms:\nle_ids/ulid.from_timestamp\nle_ids/ulid from_timestamp","url":"le_ids/ulid.html#from_timestamp"},{"doc":"le_ids/ulid","title":"generate","content":"pub fn generate() -&gt; String\n Generates an ULID.\nSynonyms:\nle_ids/ulid.generate\nle_ids/ulid generate","url":"le_ids/ulid.html#generate"},{"doc":"le_ids/ulid","title":"monotonic_from_timestamp","content":"pub fn monotonic_from_timestamp(\n  channel: Subject(Message),\n  timestamp: Int,\n) -&gt; Result(String, String)\n Generates an ULID from a timestamp using the given channel with a monotonicity check.\n This guarantees sortability if the same timestamp is used repeatedly back to back.\n\n ### Usage\n \n import ids/ulid\n\n let assert Ok(channel) = ulid.start()\n let Ok(id) = ulid.monotonic_from_timestamp(channel, 1_696_346_659_217)\n \nSynonyms:\nle_ids/ulid.monotonic_from_timestamp\nle_ids/ulid monotonic_from_timestamp","url":"le_ids/ulid.html#monotonic_from_timestamp"},{"doc":"le_ids/ulid","title":"monotonic_generate","content":"pub fn monotonic_generate(\n  channel: Subject(Message),\n) -&gt; Result(String, String)\n Generates an ULID using the given channel with a monotonicity check.\n This guarantees sortability if multiple ULID get created in the same millisecond.\n\n ### Usage\n \n import ids/ulid\n\n let assert Ok(channel) = ulid.start()\n let Ok(id) = ulid.monotonic_generate(channel)\n \nSynonyms:\nle_ids/ulid.monotonic_generate\nle_ids/ulid monotonic_generate","url":"le_ids/ulid.html#monotonic_generate"},{"doc":"le_ids/ulid","title":"start","content":"pub fn start() -&gt; Result(Subject(Message), StartError)\n Starts a ULID generator.\nSynonyms:\nle_ids/ulid.start\nle_ids/ulid start","url":"le_ids/ulid.html#start"},{"doc":"le_ids/ulid","title":"le_ids/ulid","content":" A module for generating ULIDs (Universally Unique Lexicographically Sortable Identifier).","url":"le_ids/ulid.html"},{"doc":"le_ids/uuid","title":"decode_v7","content":"pub fn decode_v7(\n  uuid_v7: String,\n) -&gt; Result(#(Int, Int, BitArray, Int, BitArray), String)\n Decodes a version 7 UUID to #(timestamp, version, random_a, rfc_variant, random_b).\nSynonyms:\nle_ids/uuid.decode_v7\nle_ids/uuid decode_v7","url":"le_ids/uuid.html#decode_v7"},{"doc":"le_ids/uuid","title":"generate_v4","content":"pub fn generate_v4() -&gt; Result(String, String)\n Generates a version 4 (random) UUID. The version 4 UUID produced\n by this function is generated using a cryptographically secure \n random number generator.\n\n ### Usage\n \n import ids/uuid\n\n let assert Ok(id) = uuid.generate_v4()\n \n\nSynonyms:\nle_ids/uuid.generate_v4\nle_ids/uuid generate_v4","url":"le_ids/uuid.html#generate_v4"},{"doc":"le_ids/uuid","title":"generate_v7","content":"pub fn generate_v7() -&gt; Result(String, String)\n Generates a version 7 UUID. The version 7 UUID produced\n by this function is generated using a cryptographically secure \n random number generator and includes a unix timestamp.\n\n ### Usage\n \n import ids/uuid\n\n let assert Ok(id) = uuid.generate_v7()\n \n\nSynonyms:\nle_ids/uuid.generate_v7\nle_ids/uuid generate_v7","url":"le_ids/uuid.html#generate_v7"},{"doc":"le_ids/uuid","title":"generate_v7_from_timestamp","content":"pub fn generate_v7_from_timestamp(\n  timestamp: Int,\n) -&gt; Result(String, String)\n Generates a version 7 UUID from a given unix timestamp in milliseconds.\nSynonyms:\nle_ids/uuid.generate_v7_from_timestamp\nle_ids/uuid generate_v7_from_timestamp","url":"le_ids/uuid.html#generate_v7_from_timestamp"},{"doc":"le_ids/uuid","title":"le_ids/uuid","content":" A module for generating UUIDs (Universally Unique Identifiers).\n\n The module currently supports UUID versions:\n - Version 4 (random)\n - Version 7 (with unix timestamp)\n","url":"le_ids/uuid.html"}]);